︠6934020d-e9a0-476a-920e-d4368a832eb7s︠
# Import Polyhedral Omega
from lds import *
from util import *
from geometry import *

# Import time for timing
from time import *

# Define a function to help choose data for the demo

def runPO(A, b, E, decomposition=True, parallelepipeds=True, rationalfunction=True, output=False):
    lds = LinearDiophantineSystem(A, b, E)
    print "A:"
    for row in lds._A:
        print row

    if decomposition == True:
        print "Computing cones"
        t1=time()
        cones = lds.symbolic_cones()
        t2=time()
        print "Cones computation took: ", t2-t1, " secs for ", len(cones), " cones"

    if parallelepipeds == True:
        print "Computing parallelepipeds"
        t3=time()
        pis = lds.fundamental_parallelepipeds()
        t4=time()
        print "Parallelepipeds computation took: ", t4-t3, " secs"

    if rationalfunction == True:
        print "Computing rational functions"
        t5=time()
        r = lds.rational_function_string()
        t6=time()
        print "Rational function computation took: ", t6-t5, " secs"

    if output == True:
        print "Symbolic Cones:"
        for c in cones:
            print(c)

    return cones, pis,r
︡695ddf02-35dd-4667-9962-a77d9317d42b︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python3.11/site-packages/smc_sagews/sage_server.py\", line 1244, in execute\n    exec(\n  File \"\", line 1, in <module>\n  File \"/home/user/lds.py\", line 46\n    print \"iteration %d of %d: %d cones (%.2f%% of theoretical maximum %d) \" % (i,len(E),num_cones,float(num_cones/max_cones)*100,max_cones)\n    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^\nSyntaxError: Missing parentheses in call to 'print'. Did you mean print(...)?\n"}︡{"done":true}
︠79abb1f7-c812-4ad2-a130-d973c6a3aa88s︠

︡0cc53534-dbbb-44d9-9f95-3953df611c22︡{"done":true}
︠1a2d6a30-5f73-425a-8c6e-45708ce37281s︠
A = []
b = []
E= []
P = polytopes.Birkhoff_polytope(3)
print(P.inequalities_list())
for i in P.inequalities_list():
    A.append(i[1:])
    b.append(-i[1])
    E.append(0)
for i in P.equations_list():
    A.append(i[1:])
    b.append(-i[1])
    E.append(1)
#print(A)
#print(b)
#print(E)
runPO(A,b,E)
cones
︡29ba92aa-13d7-4435-81a5-518633072474︡{"stdout":"[[0, 0, -1, 0, 0, 0, 1, 0, 0, 1], [0, 0, 0, 0, 0, 0, 0, 0, 0, 1], [1, 0, 0, 0, -1, 0, -1, 0, 0, 0], [1, 0, 1, 0, -1, 0, -1, 0, 0, -1], [1, 0, 0, 0, 0, 0, -1, 0, 0, -1], [0, 0, -1, 0, 1, 0, 1, 0, 0, 0], [0, 0, 0, 0, 0, 0, 1, 0, 0, 0], [0, 0, 0, 0, 1, 0, 0, 0, 0, 0], [0, 0, 1, 0, 0, 0, 0, 0, 0, 0]]\n"}︡{"stdout":"A:\n[0, -1, 0, 0, 0, 1, 0, 0, 1]\n[0, 0, 0, 0, 0, 0, 0, 0, 1]\n[0, 0, 0, -1, 0, -1, 0, 0, 0]\n[0, 1, 0, -1, 0, -1, 0, 0, -1]\n[0, 0, 0, 0, 0, -1, 0, 0, -1]\n[0, -1, 0, 1, 0, 1, 0, 0, 0]\n[0, 0, 0, 0, 0, 1, 0, 0, 0]\n[0, 0, 0, 1, 0, 0, 0, 0, 0]\n[0, 1, 0, 0, 0, 0, 0, 0, 0]\n[0, 0, 0, 1, 1, 1, 0, 0, 0]\n[1, 1, 0, 0, 0, -1, 0, 0, -1]\n[0, 1, 0, -1, 0, -1, -1, 0, -1]\n[0, 0, 1, 0, 0, 1, 0, 0, 1]\n[0, 1, 0, -1, 0, -1, 0, 1, 0]\nComputing cones\nCones computation took:  0.00887894630432  secs for  0  cones\nComputing parallelepipeds\nParallelepipeds computation took:  4.05311584473e-06  secs\nComputing rational functions\nRational function computation took:  3.09944152832e-06  secs\n(, {}, '0')\n"}︡{"stdout":"1 * [ Cone: generators = ((1, -1, 0), (1, 0, -1)), apex = (10, 0, 0), openness = (1, 1) ]  + 1 * [ Cone: generators = ((0, 1, -1), (1, 0, -1)), apex = (0, 0, 10), openness = (0, 0) ]  + -1 * [ Cone: generators = ((0, 1, -1), (1, -1, 0)), apex = (0, 10, 0), openness = (1, 0) ] \n"}︡{"done":true}
︠0dc836fd-5b81-481e-9d83-96e8dcb4a2d0s︠
A = ( (1,-1) )
b = ( 0, )
E = [ 0 ]
runPO(A,b,E)
︡e6970651-b1b8-48e9-b981-e09637ca8171︡{"stdout":"A:\n1\n-1\nComputing cones\nCones computation took:  0.000303983688354  secs for  2  cones\nComputing parallelepipeds\nParallelepipeds computation took:  0.00177907943726  secs\nComputing rational functions\nRational function computation took:  5.81741333008e-05  secs\n(1 * [ Cone: generators = ((0, 1), (1, 0)), apex = (0, 0), openness = (0, 0) ]  + -1 * [ Cone: generators = ((0, 1), (1, 1)), apex = (0, 0), openness = (1, 0) ] , {[ Cone: generators = ((0, 1), (1, 0)), apex = (0, 0), openness = (0, 0) ]: [(0, 0)], [ Cone: generators = ((0, 1), (1, 1)), apex = (0, 0), openness = (1, 0) ]: [(0, 1)]}, '1*(z0**0*z1**0)/((1-z0**0*z1**1)*(1-z0**1*z1**0))+-1*(z0**0*z1**1)/((1-z0**0*z1**1)*(1-z0**1*z1**1))')\n"}︡{"done":true}
︠f443fcb0-554e-451d-a2ef-4dfe379b4a7fs︠
A = ( (1,1,1),(1,1,1),(1,1,1) )
b = ( 10,10,10)
E = [ 1,1,1]
cones, pis,r = runPO(A,b,E)
P = PolynomialRing(QQ,["z0","z1","z2"])
print P
F = P.fraction_field()
print F
print r
rr = F(r)
sr = SR(rr)
sr.parent()
var("z0,z1,z2")
print sr
print sr(1,1,1)
#sr.series(z0==0,2)

︡20b0e427-3dc3-4d86-b4ac-97d601429ece︡{"stdout":"A:\n(1, 1, 1)\n(1, 1, 1)\n(1, 1, 1)\nComputing cones\nCones computation took:  0.000964879989624  secs for  3  cones\nComputing parallelepipeds\nParallelepipeds computation took:  0.00580501556396  secs\nComputing rational functions\nRational function computation took:  8.10623168945e-05  secs\n"}︡{"stdout":"Multivariate Polynomial Ring in z0, z1, z2 over Rational Field\n"}︡{"stdout":"Fraction Field of Multivariate Polynomial Ring in z0, z1, z2 over Rational Field\n"}︡{"stdout":"1*(z0**12*z1**-1*z2**-1)/((1-z0**1*z1**-1*z2**0)*(1-z0**1*z1**0*z2**-1))+1*(z0**0*z1**0*z2**10)/((1-z0**0*z1**1*z2**-1)*(1-z0**1*z1**0*z2**-1))+-1*(z0**0*z1**11*z2**-1)/((1-z0**0*z1**1*z2**-1)*(1-z0**1*z1**-1*z2**0))\n"}︡{"stdout":"Symbolic Ring\n"}︡{"stdout":"(z0, z1, z2)\n"}︡{"stdout":"z0^10 + z0^9*z1 + z0^8*z1^2 + z0^7*z1^3 + z0^6*z1^4 + z0^5*z1^5 + z0^4*z1^6 + z0^3*z1^7 + z0^2*z1^8 + z0*z1^9 + z1^10 + z0^9*z2 + z0^8*z1*z2 + z0^7*z1^2*z2 + z0^6*z1^3*z2 + z0^5*z1^4*z2 + z0^4*z1^5*z2 + z0^3*z1^6*z2 + z0^2*z1^7*z2 + z0*z1^8*z2 + z1^9*z2 + z0^8*z2^2 + z0^7*z1*z2^2 + z0^6*z1^2*z2^2 + z0^5*z1^3*z2^2 + z0^4*z1^4*z2^2 + z0^3*z1^5*z2^2 + z0^2*z1^6*z2^2 + z0*z1^7*z2^2 + z1^8*z2^2 + z0^7*z2^3 + z0^6*z1*z2^3 + z0^5*z1^2*z2^3 + z0^4*z1^3*z2^3 + z0^3*z1^4*z2^3 + z0^2*z1^5*z2^3 + z0*z1^6*z2^3 + z1^7*z2^3 + z0^6*z2^4 + z0^5*z1*z2^4 + z0^4*z1^2*z2^4 + z0^3*z1^3*z2^4 + z0^2*z1^4*z2^4 + z0*z1^5*z2^4 + z1^6*z2^4 + z0^5*z2^5 + z0^4*z1*z2^5 + z0^3*z1^2*z2^5 + z0^2*z1^3*z2^5 + z0*z1^4*z2^5 + z1^5*z2^5 + z0^4*z2^6 + z0^3*z1*z2^6 + z0^2*z1^2*z2^6 + z0*z1^3*z2^6 + z1^4*z2^6 + z0^3*z2^7 + z0^2*z1*z2^7 + z0*z1^2*z2^7 + z1^3*z2^7 + z0^2*z2^8 + z0*z1*z2^8 + z1^2*z2^8 + z0*z2^9 + z1*z2^9 + z2^10\n"}︡{"stdout":"66\n"}︡{"done":true}
︠404bab03-23ae-40c8-be14-4864bf0463f8s︠
A = ( (1,1,1),(1,1,1),(1,1,1) )
b = ( 10,10,10)
E = [ 1,1,1]
cones, pis,r = runPO(A,b,E)
for c in cones:
    print(c)
︡64e8d35b-44f0-44e4-bab6-5d6dc5c97acc︡{"stdout":"A:\n(1, 1, 1)\n(1, 1, 1)\n(1, 1, 1)\nComputing cones\nCones computation took:  0.00120496749878  secs for  3  cones\nComputing parallelepipeds\nParallelepipeds computation took:  0.00563383102417  secs\nComputing rational functions\nRational function computation took:  7.5101852417e-05  secs\n"}︡{"stdout":"[ Cone: generators = ((1, -1, 0), (1, 0, -1)), apex = (10, 0, 0), openness = (1, 1) ]\n[ Cone: generators = ((0, 1, -1), (1, 0, -1)), apex = (0, 0, 10), openness = (0, 0) ]\n[ Cone: generators = ((0, 1, -1), (1, -1, 0)), apex = (0, 10, 0), openness = (1, 0) ]\n"}︡{"done":true}
︠5d591885-045b-41e4-a45a-a0a190996bf1︠
︡7c648375-3561-4d5d-ada2-c7764a4de508︡
︠f0d6c08c-d5eb-407c-93bd-d5f99396e57fs︠
A = ( (1,1,1),(1,1,1),(1,1,1) )
b = ( 10,10,10)
E = [ 0,0,0]
cones, pis,r = runPO(A,b,E)
for c in cones:
    print(c)


︡ec71a731-8ea6-4a2f-80ef-8387f19f8961︡{"stdout":"A:\n(1, 1, 1)\n(1, 1, 1)\n(1, 1, 1)\nComputing cones\nCones computation took:  0.00124502182007  secs for  3  cones\nComputing parallelepipeds\nParallelepipeds computation took:  0.061665058136  secs\nComputing rational functions\nRational function computation took:  8.98838043213e-05  secs\n"}︡{"stdout":"[ Cone: generators = ((0, 0, 1), (0, 1, -1), (1, 0, -1)), apex = (0, 0, 10), openness = (0, 0, 0) ]\n[ Cone: generators = ((1, -1, 0), (1, 0, -1), (1, 0, 0)), apex = (10, 0, 0), openness = (1, 1, 0) ]\n[ Cone: generators = ((0, 1, -1), (0, 1, 0), (1, -1, 0)), apex = (0, 10, 0), openness = (1, 0, 0) ]\n"}︡{"done":true}
︠1a7a8346-1cca-4398-8f79-e9b4def40bf4s︠

︡642cb0cc-c817-43b0-95f2-fb198cd3d36f︡{"done":true}
︠58750d9e-320e-4534-bfd8-c81a1ba8be0fs︠

︡dacbe0b3-26c1-477f-92ef-835c727ecb96︡{"done":true}
︠b1372b44-1d85-4b1e-a87f-191e08c819e0s︠
︡5084dfff-a5ef-480e-8b76-5fbd8cea413d︡{"done":true}
︠35059d03-35d8-48b5-b37c-bb20a3e075cfs︠
︡66743589-24dd-47ee-88ea-95a23951ae11︡{"done":true}
︠587638ba-9552-4946-8ea7-42d837e613e2︠

            









